SystemOrganization addCategory: #'RemoteDebugger-GUI'!

Object subclass: #RDBGClientGUI
	instanceVariableNames: 'mainWindow ctlAddress ctlPort ctlStatus client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

RDBGClientGUI class
	instanceVariableNames: 'instance'!

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:41'!
instance
	instance ifNil: [instance := self new].
	^instance! !

!RDBGClientGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:40'!
open
	self instance open.! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:22'!
client
	^ RDBGClient instance! !

!RDBGClientGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 18:40'!
connectButtonEnabled
	^true
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:40'!
onCloseButtonClick
	RDBGClient shutDown.
	self updateConnectionStatus: self client getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGClientGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 23:45'!
onConnectButtonClick
	|success|
	"TODO: Do some field validation and prompt user if there is error"
	self client start.
	success := self client connectToRemoteHost.
	success ifFalse: [
		UIManager default inform: 'Connection failed'
	].

	Transcript show: 'Connect button clicked'; cr.
	self updateConnectionStatus: self client getStatusAsString.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 20:48'!
open
	|builder content dialog statusString |
	statusString := self client getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> (ctlAddress := ((builder newTextEntryFor: (self client remoteHostID) getText: #ipAddress setText: nil help: 'Host name') minWidth: 200)).
			'Connect to port' -> (ctlPort := builder newTextEntryFor: (self client remoteHostID) getText: #port setText: nil help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

	mainWindow := (content openInWindowLabeled: self title) extent: 400@130.
! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 18:47'!
title
	^'RDBG Client Connection'.! !

!RDBGClientGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 19:10'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

Object subclass: #RDBGProxyGUI
	instanceVariableNames: 'hostName portNumber ctlAddress ctlPort ctlStatus mainWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RemoteDebugger-GUI'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

RDBGProxyGUI class
	instanceVariableNames: 'instance'!

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
instance
	instance ifNil: [instance := self new hostName: 'localhost'].
	^instance! !

!RDBGProxyGUI class methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 19:39'!
open
	self instance open.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 17:20'!
connectButtonEnabled
	^ true.! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:39'!
host
	^ RDBGProxy instance! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:15'!
hostName
	^ NetNameResolver localAddressString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
hostName: aString
	hostName := aString! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 21:52'!
initialize
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 17:30'!
onCloseButtonClick
	RDBGProxy shutDown.
	self updateConnectionStatus: self host getStatusAsString.
	"Add code to disconnect RSTBroker and clean up"
	mainWindow delete.
	Transcript show: 'Close button clicked'; cr.
! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 21:55'!
onConnectButtonClick
	Transcript show: 'Connect button clicked'; cr.
	self updateModelValues.
	RDBGProxy startUp.
	self updateConnectionStatus: self host getStatusAsString.! !

!RDBGProxyGUI methodsFor: 'display' stamp: 'LionelLi 4/21/2013 22:05'!
open
	|builder content dialog statusString |
	statusString := self host getStatusAsString.
	builder := UITheme builder.
	content := builder newColumn: {
		builder newLabelGroup: {
			'Host address' -> ((builder newTextEntryFor: (self host hostID) getText: #ipAddress setText: #ipAddress: help: 'Host name') disable; minWidth: 200).
			'Listen to port' -> (ctlPort := builder newTextEntryFor: (self host hostID) getText: #port setText: #port: help: 'Port number').
			'Status ' -> (ctlStatus := (builder newLabel: statusString)).
		}.
		(builder newRow: {
			(builder newButtonFor: self action: #onConnectButtonClick getEnabled: #connectButtonEnabled label: 'Connect' help: 'Connect to address').
			(builder newButtonFor: self action: #onCloseButtonClick getEnabled: nil label: 'Close' help: 'Disconnect and close remote debugger').
		} ) listCentering: #bottomRight
	}.

"	dialog := builder newPluggableDialogWindow: 'Proxy Connection Window'  for: content.
	dialog useOKDefaultCancelButton.
	dialog rememberKeyboardFocus: ctlPort.
	builder openModal: dialog.
"
	mainWindow := (content openInWindowLabeled: self title) extent: 400@130; rememberKeyboardFocus: ctlPort.
! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 15:09'!
portNumber
	^portNumber ifNil: [portNumber := '9999']! !

!RDBGProxyGUI methodsFor: 'accessing' stamp: 'LionelLi 4/21/2013 04:04'!
portNumber: aString
	portNumber := aString asInteger! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 18:42'!
title
	^ 'rDBG Proxy Connection'! !

!RDBGProxyGUI methodsFor: 'as yet unclassified' stamp: 'LionelLi 4/21/2013 15:07'!
updateConnectionStatus: aString
	ctlStatus contents: aString! !

!RDBGProxyGUI methodsFor: 'callbacks' stamp: 'LionelLi 4/21/2013 22:05'!
updateModelValues
	self host hostID port: ctlPort getText asInteger.
! !
